#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sysexits.h>
#include <unistd.h>

#define MAXROW 80

#ifndef true
#define true  1
#define false 0
#endif

struct AddressList
{
    char *snder ;
    struct AddressList *next ;
};

struct AddressList *hdr , *end ;

int ReadAddressList ( char * ) ;
int SearchAddress ( char * ) ;
int AddAddress ( char * ) ;
int err_exit ( char * ) ;

int ReadAddressList ( char *fname )
{
    FILE *fp ;
    char rowstr[MAXROW] ;
    int len ;

    fp = fopen ( fname , "r" ) ;
    if ( !fp )
        err_exit ( "file open" ) ;
    printf ( "Debarred list:\n" ) ;
    while ( fgets ( rowstr , MAXROW , fp ) )
    {
        len = strlen ( rowstr ) ;
        if ( len == MAXROW - 1 ) /* MAXROW limit exceeded */
            err_exit ( "MAXROW limit" ) ;
        if ( rowstr[len - 1] == '\n' )
            rowstr[len - 1] = '\0' ;
        if ( len > 1 )
            AddAddress ( rowstr ) ;
    }
    return 0 ;
}

int AddAddress ( char *addr )
{
    struct AddressList *tmp ;
    
    tmp = ( struct AddressList * ) malloc ( sizeof ( struct AddressList ) ) ;
    if ( !tmp )
        err_exit ( "mem alloc" ) ;
    printf ( "<%s>.\n" , addr ) ;
    tmp -> snder = strdup ( addr ) ;
    if ( ! ( tmp -> snder ) )
        err_exit ( "mem alloc" ) ;
    tmp -> next = NULL ;
    
    if ( !hdr )
    {
        hdr = end = tmp ;
        return 0 ;
    }
    end -> next = tmp ;
    end = tmp ;
    return 0 ;
}

int SearchAddress ( char *addr )
{
    struct AddressList *tmp ;

    tmp = hdr ;
    while ( tmp )
    {
        if ( strstr ( addr , tmp -> snder ) )
            return true ;
        tmp = tmp -> next ;
    }
    return false ;
}
